
; ========================================================
;			
;    -- Graph.asm --
;			Jay Sullivan
; ========================================================
  
.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include Graph.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		CeeOfExWye PROTO
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND


	;------------------------------------------------
	;	Main Window Class
	;------------------------------------------------
		
		mov wc.cbSize, Sizeof WNDCLASSEX
		mov wc.style, CS_HREDRAW or CS_VREDRAW
		mov wc.lpfnWndProc, Offset WndProc
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,NULL
		mov eax,hInst
		mov wc.hInstance,eax
		mov wc.hbrBackground, COLOR_WINDOW+1
		mov wc.lpszMenuName, NULL
		mov wc.lpszClassName, Offset ClassName
		invoke LoadIcon, NULL, IDI_APPLICATION
		mov wc.hIcon,eax
		mov wc.hIconSm,0
		invoke LoadCursor, NULL, IDC_ARROW
		mov wc.hCursor,eax
		invoke RegisterClassEx, ADDR wc
		
	;------------------------------------------------
	;	Windows
	;------------------------------------------------
		
		;-----------------------------
		;	Main Window
		;-----------------------------
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,350,400,\
				NULL,0,hInst,NULL
			mov hwnd,eax
				
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP

;------------------------------------------------
;	WndProc
;------------------------------------------------
align 8
.data?
CUR_X REAL8 ?
CUR_Y REAL8 ?

CUR_X_int dd ?
CUR_Y_int dd ?

CUR_COLOR dd ?

Y_MIN dd ?
Y_MAX dd ?

X_MIN dd ?
X_MAX dd ?

WINDOW_WIDTH dd ?
WINDOW_HEIGHT dd ?

ps PAINTSTRUCT <>
.code

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL hBrush:HBRUSH, hPen:HPEN,
	  hdc:HDC
	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------
		
        invoke DeleteDC,hdc
		invoke PostQuitMessage, NULL
		

	;-----------------------------
	 .elseif uMsg==WM_SIZE
	;-----------------------------
	
	  movzx eax, HIWORD(lParam)
	  movzx ecx, LOWORD(lParam)
	  mov WINDOW_HEIGHT, eax
	  mov WINDOW_WIDTH, ecx
	  
	  mov X_MIN, -500
	  mov X_MAX, 500
	  mov Y_MIN, -500
	  mov Y_MAX, 500
	  
	;-----------------------------
	 .elseif uMsg==WM_PAINT
	;-----------------------------
	
		;-----------------------------
		; Setup
		;-----------------------------
	
	
		invoke BeginPaint,hWnd, Offset ps
		mov hdc, eax
		
		invoke SetMapMode,hdc,MM_LOMETRIC
		mov eax, WINDOW_HEIGHT
		mov ecx, WINDOW_WIDTH
		shr eax, 1
		shr ecx, 1
		invoke SetViewportOrgEx,hdc,ecx,eax,0
		;-----------------------------
		; Draw
		;-----------------------------
		
		;-----------------------------
		; Grid
		;-----------------------------
			invoke CreatePen,PS_SOLID,1,0FF00h
			mov hPen, eax
			invoke SelectObject,hdc,hPen
			invoke Rectangle,hdc,X_MIN,Y_MIN,X_MAX,Y_MAX
			invoke Rectangle,hdc,-100,-100,100,100
		;-----------------------------
		; Graph
		;-----------------------------
			finit
			
		;-----------------------------
		; Rows
		;-----------------------------
			fild Y_MIN
			fst CUR_Y
			fistp CUR_Y_int
		nextrow:
			
			
				;-----------------------------
				; Columns
				;-----------------------------
					fild X_MIN
					fst CUR_X
					fistp CUR_X_int
				nextcolumn:
					invoke CeeOfExWye			
					invoke SetPixel,hdc,CUR_X_int,CUR_Y_int,CUR_COLOR
					
					fld $float(1.0) ; st(0)
					fadd CUR_X      ; st(0)
					fst  CUR_X      ; st(0)
					fistp CUR_X_int      ; st(0)
					mov eax, CUR_X_int
					cmp eax, X_MAX
					jl nextcolumn       ;
				
				
			fld $float(1.1)            ; st(0)
			fadd CUR_Y      ; st(0)
			fst  CUR_Y      ; st(0)
			fistp CUR_Y_int      ; st(0)
			mov eax, CUR_Y_int
			cmp eax, Y_MAX
			jl nextrow       ;
			
			
		;-----------------------------
		; Setdown
		;-----------------------------
		
		invoke DeleteObject,hPen
        invoke EndPaint,hWnd, Offset ps
        
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


CeeOfExWye PROC
LOCAL temp:DWORD
	fld CUR_X
	fld CUR_Y
	
	fmul
	
	
	fistp CUR_COLOR
	ret
CeeOfExWye ENDP

End Start